retrie-1.2.2: A powerful, easy-to-use codemodding tool for Haskell.

Safe Haskell | Safe-Inferred
Language | Haskell2010

Retrie.Context

Synopsis

- type ContextUpdater = forall m. MonadIO m => GenericCU (TransformT m) Context
- updateContext :: forall m. MonadIO m => GenericCU (TransformT m) Context
- emptyContext :: FixityEnv -> Rewriter -> Rewriter -> Context

# Documentation

type ContextUpdater = forall m. MonadIO m => GenericCU (TransformT m) Context #

Type of context update functions for `apply`. When defining your own `ContextUpdater`, you probably want to extend `updateContext` using SYB combinators such as `mkQ` and `extQ`.

updateContext :: forall m. MonadIO m => GenericCU (TransformT m) Context #

Default context update function.

emptyContext :: FixityEnv -> Rewriter -> Rewriter -> Context #

Create an empty `Context` with given `FixityEnv`, rewriter, and dependent rewrite generator.